﻿<?php
/*
Plugin Name: mlPostSlider
Plugin URI: http://www.mlipinski.pl/plugins/mlPostSlider
Description: Display Your posts in widget slider.
Version: 1.0
Author: Michal Lipinski
Author URI: http://www.mlipinski.pl
License: GPLv2
*/
add_action( 'widgets_init', 'ml_post_slider_init');
add_action( 'init','ml_add_script_library');

function ml_add_script_library(){
wp_enqueue_script( 'jquery');
$plugin_dir= plugin_dir_url(__FILE__);
wp_enqueue_script( 'jquerycycle' , $plugin_dir.'js/jquery-cycle.js');
}


function ml_post_slider_init(){
	register_widget('ml_post_slider_widget' );
}

class ml_post_slider_widget extends WP_Widget{
	function ml_post_slider_widget (){
		$widget_ops= array(
			'classname' => 'ml_post_slider_widget',
			'description' => 'With this widget you can create professional slider in your website.');
			$this->WP_Widget( 'ml_post_slider_widget' , 'ML Post Slider', $widget_ops );
	}
	
	function form($instance){
		$defaults= array( 'ml_category' => '', 'ml_width' => 100, 'ml_height'=> 100, 'ml_delay' => 1000, 'ml_unique_id' => date('Ymdhis'), 'ml_effect' => 'fade');
		$instance = wp_parse_args( (array) $instance, $defaults);
		$ml_category = $instance['ml_category'];
		$ml_width= $instance['ml_width'];
		$ml_height= $instance['ml_height'];
		$ml_unique_id= $instance['ml_unique_id'];
		$ml_delay = $instance['ml_delay'];
		$ml_effect = $instance['ml_effect'];
		$ml_arrows= $instance['ml_arrows'];
		?>
		<input type="hidden" name="<?php echo $this->get_field_name('ml_unique_id'); ?>" value="<?php echo date('Ymdhis'); ?>" />
		<p>Post Category: 
		<select name="<?php echo $this->get_field_name('ml_category'); ?>">
		<?php
		$args=array(
			'orderby' => 'name',
			'order' => 'ASC'
		);
		$categories=get_categories($args);
		foreach ($categories as $kategoria) {
		?>
			<option value="<?php echo $kategoria->term_id ?>" <?php selected($ml_category, $kategoria->term_id) ?>><?php echo $kategoria->name ?></option>
		<?php
		} 
		?>
		</select></p>
		<p>Slider width:
			<input type="text" name="<?php echo $this->get_field_name('ml_width'); ?>" value="<?php echo esc_attr( $ml_width); ?>" size="3" /> <i>[px]</i>
		</p>
		<p>Slider height:
			<input type="text" name="<?php echo $this->get_field_name('ml_height'); ?>" value="<?php echo esc_attr( $ml_height); ?>" size="3" /> <i>[px]</i>
		</p>
		<p>Delay:
			<input type="text" name="<?php echo $this->get_field_name('ml_delay'); ?>" value="<?php echo esc_attr( $ml_delay/1000); ?>" size="3" /> <i>[sec.]</i>
		</p>
		<p>Effect: 
		<select name="<?php echo $this->get_field_name('ml_effect'); ?>">
			<option value="fade" <?php selected($ml_effect, 'fade') ?>>fade</option>
			<option value="scrollHorz" <?php selected($ml_effect, 'scrollHorz') ?>>scroll horizontal</option>
			<option value="scrollLeft" <?php selected($ml_effect, 'scrollLeft') ?>>scroll left</option>
			<option value="scrollRight" <?php selected($ml_effect, 'scrollRight') ?>>scroll right</option>
		</select></p>
		<p>Navigation arrows<i>[on/off]:</i>
			<input name="<?php echo $this->get_field_name( 'ml_arrows' ); ?>" type="checkbox" <?php checked( $ml_arrows, 'on'); ?> /></p>
		<?php
	}
	
	function update($new_instance, $old_instance){
		$instance = $old_instance;
		if (strlen(sanitize_text_field($new_instance['ml_category']))<255) $instance['ml_category']= sanitize_text_field($new_instance['ml_category']);
		if (sanitize_text_field(is_numeric($new_instance['ml_width'])) && (strlen($new_instance['ml_width'])<5)) $instance['ml_width']= abs(sanitize_text_field($new_instance['ml_width']));
		if (sanitize_text_field(is_numeric($new_instance['ml_height'])) && (strlen($new_instance['ml_width'])<5)) $instance['ml_height']= abs(sanitize_text_field($new_instance['ml_height']));
		if ((!isset($instance['ml_unique_id'])) && (is_numeric($new_instance['ml_unique_id'])) && (strlen($new_instance['ml_unique_id']) ==14)) $instance['ml_unique_id']= abs($new_instance['ml_unique_id']);
		if ((is_numeric($new_instance['ml_delay'])) && (strlen($new_instance['ml_delay'])<3)) $instance['ml_delay']= abs($new_instance['ml_delay']*1000);
		switch (sanitize_text_field($new_instance['ml_effect'])){
			case 'scrollHorz': $instance['ml_effect'] = 'scrollHorz'; break;
			case 'scrollLeft': $instance['ml_effect'] = 'scrollLeft'; break;
			case 'scrollRight': $instance['ml_effect'] = 'scrollRight'; break;
			default: $instance['ml_effect'] = 'fade';
		}
		$instance['ml_arrows'] = sanitize_text_field($new_instance['ml_arrows']);
		return $instance;
	}

	function widget($args, $instance){
		$delay=$instance['ml_delay'];
		echo '<script type="text/javascript">

				jQuery(document).ready(function() {
					jQuery(".ml_post_slider'.$instance['ml_unique_id'].'").cycle({
						fx: "'.$instance['ml_effect'].'", 
						timeout: '.$delay.',
						prev: "#prev'.$instance['ml_unique_id'].'",
						next: "#next'.$instance['ml_unique_id'].'"
					});';
		// Display navigation arrows if it is "on"
		if (isset($instance['ml_arrows']) && ($instance['ml_arrows']=='on'))
			echo ' 	jQuery(".parrent_ml_post_slider'.$instance['ml_unique_id'].'").hover(function() {
					jQuery("ul#nav'.$instance['ml_unique_id'].'").fadeIn();
					},
					function() {
						jQuery("ul#nav'.$instance['ml_unique_id'].'").fadeOut();
					});	';
		//------------------------------------------------
		
		echo 'jQuery(".parrent_ml_post_slider'.$instance['ml_unique_id'].'").hover(function() { 
				jQuery(".ml_post_slider'.$instance['ml_unique_id'].'").cycle("pause"); 
			},function() {
				jQuery(".ml_post_slider'.$instance['ml_unique_id'].'").cycle("resume");
			});
				
		';		
		echo '	});</script>';
		echo '<div class="parrent_ml_post_slider'.$instance['ml_unique_id'].'" style="overflow:hidden;">';
		echo '<div class="ml_post_slider'.$instance['ml_unique_id'].'" style="width:'.$instance['ml_width'].'px; height:'.$instance['ml_height'].'px;overflow:hidden;">';
		global $post;
		$args=array('category' => $instance['ml_category'], 'post_type' => 'post');
		$posts_array = get_posts( $args ); 
		foreach($posts_array as $post){
			echo '<div style="width:'.$instance['ml_width'].'; height:'.$instance['ml_height'].';overflow:hidden;">'.$post->post_content.'</div>';
		}
		echo '</div>
			<ul id="nav'.$instance['ml_unique_id'].'" style="display: none;text-indent: -9999px;z-index:100;float:right; ">
				<li id="prev'.$instance['ml_unique_id'].'" style="width: 25px; float:left;height: 25px;background: url('.plugin_dir_url(__FILE__).'images/prev.png);z-index:1000;"><a href="#">Previous</a></li>
				<li id="next'.$instance['ml_unique_id'].'" style="width: 25px; height: 25px;margin-left:25px;background: url('.plugin_dir_url(__FILE__).'images/next.png);z-index:1000;"><a href="#">Next</a></li>
			</ul></div>';
	}
}



?>
